package org.example.domainmodel.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.example.domainmodel.domainmodel.ComponentInstance;
import org.example.domainmodel.domainmodel.DataInstance;
import org.example.domainmodel.domainmodel.DataSet;
import org.example.domainmodel.domainmodel.GateType;
import org.example.domainmodel.domainmodel.TestConfiguration;
import org.example.domainmodel.domainmodel.TestDescription;

@SuppressWarnings("all")
public class DomainmodelGenerator implements IGenerator {
  @Inject
  @Extension
  private IQualifiedNameProvider _iQualifiedNameProvider;
  
  private String dataSet = "";
  
  private String gate = "";
  
  private String defaultGate = "";
  
  private String importHdr = "";
  
  public String getDataSet(final Resource resource) {
    String values = "module DataModule \n{\n";
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
    Iterable<DataSet> _filter = Iterables.<DataSet>filter(_iterable, DataSet.class);
    for (final DataSet e : _filter) {
      String _values = values;
      CharSequence _compileDataSet = this.compileDataSet(e);
      values = (_values + _compileDataSet);
    }
    return values;
  }
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    String _dataSet = this.getDataSet(resource);
    String _plus = (_dataSet + "}");
    fsa.generateFile("DataModule.ttcn3", _plus);
    this.importHdr = "   import from DataModule type ";
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
    Iterable<DataSet> _filter = Iterables.<DataSet>filter(_iterable, DataSet.class);
    for (final DataSet x : _filter) {
      String _dataSet_1 = this.dataSet;
      QualifiedName _fullyQualifiedName = this._iQualifiedNameProvider.getFullyQualifiedName(x);
      String _string = _fullyQualifiedName.toString();
      String _plus_1 = (_string + "Type,");
      this.dataSet = (_dataSet_1 + _plus_1);
    }
    int _length = this.dataSet.length();
    int _minus = (_length - 1);
    String _substring = this.dataSet.substring(0, _minus);
    this.dataSet = _substring;
    String _dataSet_2 = this.dataSet;
    this.dataSet = (_dataSet_2 + ";\n");
    TreeIterator<EObject> _allContents_1 = resource.getAllContents();
    Iterable<EObject> _iterable_1 = IteratorExtensions.<EObject>toIterable(_allContents_1);
    Iterable<GateType> _filter_1 = Iterables.<GateType>filter(_iterable_1, GateType.class);
    for (final GateType x_1 : _filter_1) {
      String _gate = this.gate;
      QualifiedName _fullyQualifiedName_1 = this._iQualifiedNameProvider.getFullyQualifiedName(x_1);
      String _string_1 = _fullyQualifiedName_1.toString();
      this.gate = (_gate + _string_1);
    }
    boolean _notEquals = (!Objects.equal(this.gate, ""));
    if (_notEquals) {
      this.defaultGate = this.gate;
      this.gate = (("\ttype port " + this.gate) + " message {\n");
    }
    int _indexOf = this.dataSet.indexOf(" ");
    int _plus_2 = (_indexOf + 1);
    String _substring_1 = this.dataSet.substring(_plus_2);
    this.dataSet = _substring_1;
    int pos = 0;
    int commaPos = this.dataSet.indexOf(",", pos);
    String _substring_2 = this.dataSet.substring(pos, commaPos);
    String _plus_3 = ("\t\tinout " + _substring_2);
    String portStr = (_plus_3 + ";\n");
    pos = commaPos;
    String _portStr = portStr;
    String _substring_3 = this.dataSet.substring((pos + 1));
    String _plus_4 = ("\t\tinout " + _substring_3);
    String _plus_5 = (_plus_4 + "\t}\n");
    portStr = (_portStr + _plus_5);
    String componentStr = "";
    TreeIterator<EObject> _allContents_2 = resource.getAllContents();
    Iterable<EObject> _iterable_2 = IteratorExtensions.<EObject>toIterable(_allContents_2);
    Iterable<TestConfiguration> _filter_2 = Iterables.<TestConfiguration>filter(_iterable_2, TestConfiguration.class);
    for (final TestConfiguration q : _filter_2) {
      String _componentStr = componentStr;
      CharSequence _compileTestConfig = this.compileTestConfig(q);
      componentStr = (_componentStr + _compileTestConfig);
    }
    TreeIterator<EObject> _allContents_3 = resource.getAllContents();
    Iterable<EObject> _iterable_3 = IteratorExtensions.<EObject>toIterable(_allContents_3);
    Iterable<TestConfiguration> _filter_3 = Iterables.<TestConfiguration>filter(_iterable_3, TestConfiguration.class);
    for (final TestConfiguration e : _filter_3) {
      QualifiedName _fullyQualifiedName_2 = this._iQualifiedNameProvider.getFullyQualifiedName(e);
      String _string_2 = _fullyQualifiedName_2.toString("/");
      String _plus_6 = (_string_2 + ".ttcn3");
      CharSequence _compileTestConfigHdr = this.compileTestConfigHdr(e);
      String _plus_7 = (_compileTestConfigHdr + this.importHdr);
      String _plus_8 = (_plus_7 + this.dataSet);
      String _plus_9 = (_plus_8 + this.gate);
      String _plus_10 = (_plus_9 + portStr);
      String _plus_11 = (_plus_10 + componentStr);
      fsa.generateFile(_plus_6, _plus_11);
    }
    TreeIterator<EObject> _allContents_4 = resource.getAllContents();
    Iterable<EObject> _iterable_4 = IteratorExtensions.<EObject>toIterable(_allContents_4);
    Iterable<TestDescription> _filter_4 = Iterables.<TestDescription>filter(_iterable_4, TestDescription.class);
    for (final TestDescription e_1 : _filter_4) {
      QualifiedName _fullyQualifiedName_3 = this._iQualifiedNameProvider.getFullyQualifiedName(e_1);
      String _string_3 = _fullyQualifiedName_3.toString("/");
      String _plus_12 = (_string_3 + ".ttcn3");
      CharSequence _compileTestDescHdr = this.compileTestDescHdr(e_1);
      fsa.generateFile(_plus_12, _compileTestDescHdr);
    }
  }
  
  public CharSequence compileTestDescHdr(final TestDescription e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("module ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.newLineIfNotEmpty();
    _builder.append("{");
    _builder.newLine();
    _builder.append("\t ");
    _builder.append("import from ");
    TestConfiguration _testConfiguration = e.getTestConfiguration();
    String _name_1 = _testConfiguration.getName();
    _builder.append(_name_1, "\t ");
    _builder.append(" all;");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence compileTestConfigHdr(final TestConfiguration e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("module ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.newLineIfNotEmpty();
    _builder.append("{");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence compileTestConfig(final TestConfiguration e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<ComponentInstance> _componentInstance = e.getComponentInstance();
      for(final ComponentInstance t : _componentInstance) {
        CharSequence _compileComponent = this.compileComponent(t);
        _builder.append(_compileComponent, "");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence compileComponent(final ComponentInstance e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\t", "");
    _builder.append("type component ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t", "");
    _builder.append("port ");
    _builder.append(this.defaultGate, "");
    _builder.append(" ");
    _builder.append("g", "");
    String _name_1 = e.getName();
    _builder.append(_name_1, "");
    _builder.append(" ");
    _builder.append(";\n\t}", "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence compileDataSet(final DataSet e) {
    StringConcatenation _builder = new StringConcatenation();
    String dataset = e.getName();
    _builder.newLineIfNotEmpty();
    _builder.append("\t", "");
    _builder.append("type record ");
    _builder.append(dataset, "");
    _builder.append("Type {");
    _builder.newLineIfNotEmpty();
    {
      EList<DataInstance> _dataInstance = e.getDataInstance();
      for(final DataInstance d : _dataInstance) {
        CharSequence _compileRecord = this.compileRecord(d);
        _builder.append(_compileRecord, "");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t", "");
    _builder.append("} ");
    _builder.newLineIfNotEmpty();
    _builder.append("\t", "");
    _builder.append("template ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.append("Type TemplateType := {");
    _builder.newLineIfNotEmpty();
    {
      EList<DataInstance> _dataInstance_1 = e.getDataInstance();
      for(final DataInstance t : _dataInstance_1) {
        CharSequence _compileTemplate = this.compileTemplate(t);
        _builder.append(_compileTemplate, "");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t", "");
    _builder.append("}");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence compileRecord(final DataInstance d) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\t\t", "");
    _builder.append(" Temptype ");
    String _name = d.getName();
    _builder.append(_name, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence compileTemplate(final DataInstance t) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\t\t", "");
    _builder.append(" ");
    String _name = t.getName();
    _builder.append(_name, "");
    _builder.append(" := \"TempValue\"  ");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
